#include "Fit/Param/RealLimits.h"
#include "Param/Base/IParametric.h"
#include "Tests/GTestWrapper/google_test.h"
#include <stdexcept>

class IParametricTest : public ::testing::Test {
protected:
    class TestClass : public IParametric {
    public:
        using IParametric::checkLimits; // make it public
    };
};

TEST_F(IParametricTest, checkLimits)
{
    // this checks only the function if IParametricTest::checkLimits() in principle. More
    // tests regarding RealLimits shall be done in dedicated RealLimits unit tests
    TestClass t;
    EXPECT_NO_THROW(t.checkLimits("A", 0, RealLimits::nonnegative()));
    EXPECT_THROW(t.checkLimits("A", 0, RealLimits::positive()), std::runtime_error);
    EXPECT_NO_THROW(t.checkLimits("A", -1, RealLimits::limitless()));
}
